`timescale 1ns/1ps
`define TEST_LEN 8
module tb ();

reg [3:0] in0, in1, in2, in3;
reg clk, rst_n, enable;

wire [3:0] min,max;
wire valid;

always #5 clk = !clk;
integer  i, file;
reg [3:0]  data [`TEST_LEN * 4 - 1:0];
reg [3:0]  predict [`TEST_LEN * 2 - 1:0];
reg [3:0] result [`TEST_LEN * 4 - 1:0];

initial begin
    clk = 1'b1;
    rst_n = 1'b0;
    enable = 1'b0;
    in0 = 'd0;
    in1 = 'd0;
    in2 = 'd0;
    in3 = 'd0;
    $readmemh("./datas/data4.txt", data);
    $readmemh("./datas/data4.txt", result);
    # 20 
    rst_n = 1'b1;
    # 5
    enable = 1'b1;
    for(i = 0;i < (`TEST_LEN  + 1);i = i + 1) begin
        if(i < `TEST_LEN) begin
            in0 = data[i * 4];
            in1 = data[i * 4 + 1];
            in2 = data[i * 4 + 2];
            in3 = data[i * 4 + 3];
        end
        else begin
            enable = 1'b0;
        end
        if(i > 0) begin
            predict[(i-1) * 2] = min;
            predict[(i-1) * 2  + 1] = max;
           
        end
        # 10 ;
    end
    writePredict();
    sortResult();
    compare();
    $stop;
end

min_max min_max4(
    .clk(clk),
    .rst_n(rst_n),
    .enable(enable),
    .in0(in0),
    .in1(in1),
    .in2(in2),
    .in3(in3),
    .min(min),
    .max(max),
    .valid(valid)
);

task writePredict;
integer i;
begin
    file = $fopen("result.txt", "w+");
    for(i = 0;i < `TEST_LEN;i = i + 1) begin
        $fwrite(file, "%dth input data = %2d %2d %2d %2d\n          min = %2d max = %2d \n\n", i, data[i * 4],data[i * 4 + 1], data[i * 4 + 2], data[i * 4 + 3], predict[i * 2], predict[i * 2 + 1]);
    end
end


endtask 

task sortResult;
integer  i;
begin
    for(i = 0;i < `TEST_LEN;i = i + 1)begin
        sort2(result[i * 4], result[i * 4 + 1]);
        sort2(result[i * 4], result[i * 4 + 2]);
        sort2(result[i * 4], result[i * 4 + 3]);
        sort2(result[i * 4 + 1], result[i * 4 + 2]);
        sort2(result[i * 4 + 1], result[i * 4 + 3]);
        sort2(result[i * 4 + 2], result[i * 4 + 3]);
    end
end
endtask

task sort2;
inout [3:0] in1;
inout [3:0] in2;
begin
    if(in1 < in2) begin
        in1 = in1 ^ in2;
        in2 = in1 ^ in2;
        in1 = in1 ^ in2;
    end
end
endtask 

task compare;
integer  i;
integer  j;
begin
    j = 0;
    for(i = 0;i < `TEST_LEN ;i = i + 1) begin
        if(predict[i*2] != result[i*4+3] || predict[i*2+1] != result[i*4]) begin
            j = j + 1;
        end
    end
    if(j == 0) begin
        $display("~~~~~~~~~~~~~~~~~~~ TEST_PASS ~~~~~~~~~~~~~~~~~~~");
        $display("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        $display("~~~~~~~~~ #####     ##     ####    #### ~~~~~~~~~");
        $display("~~~~~~~~~ #    #   #  #   #       #     ~~~~~~~~~");
        $display("~~~~~~~~~ #    #  #    #   ####    #### ~~~~~~~~~");
        $display("~~~~~~~~~ #####   ######       #       #~~~~~~~~~");
        $display("~~~~~~~~~ #       #    #  #    #  #    #~~~~~~~~~");
        $display("~~~~~~~~~ #       #    #   ####    #### ~~~~~~~~~");
        $display("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
    end
    else begin
        $display("~~~~~~~~~~~~~~~~~~~ TEST_FAIL ~~~~~~~~~~~~~~~~~~~~");
        $display("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        $display("~~~~~~~~~~######    ##       #    #     ~~~~~~~~~~");
        $display("~~~~~~~~~~#        #  #      #    #     ~~~~~~~~~~");
        $display("~~~~~~~~~~#####   #    #     #    #     ~~~~~~~~~~");     
        $display("~~~~~~~~~~#       ######     #    #     ~~~~~~~~~~");
        $display("~~~~~~~~~~#       #    #     #    #     ~~~~~~~~~~");
        $display("~~~~~~~~~~#       #    #     #    ######~~~~~~~~~~");
        $display("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
    end
end
endtask 

endmodule